com.orsoncharts.data.xyz

## Class XYZItemKey<S extends java.lang.Comparable<S>>

- java.lang.Object
- - com.orsoncharts.data.xyz.XYZItemKey<S>

- All Implemented Interfaces:
    ItemKey, java.io.Serializable, java.lang.Comparable<XYZItemKey<S>>

      public class XYZItemKey<S extends java.lang.Comparable<S>>
      extends java.lang.Object
      implements ItemKey, java.lang.Comparable<XYZItemKey<S>>, java.io.Serializable

  An object that references one data item in an `XYZDataset`. This is used internally to track the data item that a 3D object is related to, if any (and later that link is used for chart interaction). Instances of this class are immutable.
  Since:
    1.3
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `XYZItemKey(S seriesKey, int itemIndex)` Creates a new instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(XYZItemKey<S> key)`
    `boolean` | `equals(java.lang.Object obj)` Tests this instance for equality with an arbitrary object.
    `int` | `getItemIndex()` Returns the item index.
    `S` | `getSeriesKey()` Returns the series key.
    `int` | `hashCode()`
    `java.lang.String` | `toJSONString()` Returns a JSON formatted string representing the key.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### XYZItemKey

          public XYZItemKey(S seriesKey,
                            int itemIndex)

      Creates a new instance.
      Parameters:
        `seriesKey` - the series key (`null` not permitted).
        `itemIndex` - the item index.

  - ### Method Detail

    - #### getSeriesKey

          public S getSeriesKey()

      Returns the series key.
      Returns:
        The series key (never `null`).

    - #### getItemIndex

          public int getItemIndex()

      Returns the item index.
      Returns:
        The item index.

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests this instance for equality with an arbitrary object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - the object to test (`null` permitted).
      Returns:
        A boolean.

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toJSONString

          public java.lang.String toJSONString()

      Description copied from interface: `ItemKey`
      Returns a JSON formatted string representing the key.
      Specified by:
        `toJSONString` in interface `ItemKey`
      Returns:
        A JSON formatted string.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### compareTo

          public int compareTo(XYZItemKey<S> key)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<XYZItemKey<S extends java.lang.Comparable<S>>>`